## linux 6.8.0-78.78trisquel35

=== debian/changelog ===
linux (6.8.0-78.78trisquel35) ecne; urgency=medium

  * Removed non-free bits

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 18 Aug 2025 18:45:39 +0000

linux (6.8.0-78.78) noble; urgency=medium

  * noble/linux: 6.8.0-78.78 -proposed tracker (LP: #2120405)

  * Incorrect backport for CVE-2025-21861 causes kernel hangs
    (LP: #2120330) // CVE-2025-21861
    - mm/migrate_device: don't add folio to be freed to LRU in
      migrate_device_finalize()

  * Incorrect backport for CVE-2025-21861 causes kernel hangs (LP: #2120330)
    - SAUCE: Revert "mm/migrate_device: don't add folio to be freed to LRU in
      migrate_device_finalize()"
    - mm: migrate_device: use more folio in migrate_device_finalize()

 -- Stefan Bader <stefan.bader@canonical.com>  Tue, 12 Aug 2025 11:44:16 +0200

linux (6.8.0-72.72) noble; urgency=medium

  * noble/linux: 6.8.0-72.72 -proposed tracker (LP: #2117691)

  * Packaging resync (LP: #1786013)
    - [Packaging] update annotations scripts
    - [Packaging] debian.master/dkms-versions -- update from kernel-versions
      (main/2025.07.14)

  * NVMe namespace ID mismatch on repeated map/unmap (LP: #2115209)
    - nvme: requeue namespace scan on missed AENs
    - nvme: re-read ANA log page after ns scan completes
    - nvme: fixup scan failure for non-ANA multipath controllers

  * integrated I219-LM network adapter appears to be running too fast, causing
    synchronization issues when using the I219-LM PTP feature (LP: #2116072)
    - e1000e: set fixed clock frequency indication for Nahum 11 and Nahum 13

  * intel_rapl: support ARL-H hardware (LP: #2115652)
    - powercap: intel_rapl_msr: Add PL4 support for ArrowLake-H

  * Ubuntu 24.04+ arm64: screen resolution fixed to 1024x768 with last kernel
    update (LP: #2115068)
    - [Config] Replace FB_HYPERV with DRM_HYPERV

  * Noble update: upstream stable patchset 2025-07-09 (LP: #2116212)
    - arm64: mte: Do not allow PROT_MTE on MAP_HUGETLB user mappings
    - xfs: assert a valid limit in xfs_rtfind_forw
    - xfs: validate inumber in xfs_iget
    - xfs: fix a sloppy memory handling bug in xfs_iroot_realloc
    - xfs: fix a typo
    - xfs: skip background cowblock trims on inodes open for write
    - xfs: don't free cowblocks from under dirty pagecache on unshare
    - xfs: merge xfs_attr_leaf_try_add into xfs_attr_leaf_addname
    - xfs: return bool from xfs_attr3_leaf_add
    - xfs: distinguish extra split from real ENOSPC from xfs_attr3_leaf_split
    - xfs: distinguish extra split from real ENOSPC from
      xfs_attr_node_try_addname
    - xfs: fold xfs_bmap_alloc_userdata into xfs_bmapi_allocate
    - xfs: don't ifdef around the exact minlen allocations
    - xfs: call xfs_bmap_exact_minlen_extent_alloc from xfs_bmap_btalloc
    - xfs: support lowmode allocations in xfs_bmap_exact_minlen_extent_alloc
    - xfs: Use try_cmpxchg() in xlog_cil_insert_pcp_aggregate()
    - xfs: Remove empty declartion in header file
    - xfs: pass the exact range to initialize to xfs_initialize_perag
    - xfs: update the file system geometry after recoverying superblock
      buffers
    - xfs: error out when a superblock buffer update reduces the agcount
    - xfs: don't use __GFP_RETRY_MAYFAIL in xfs_initialize_perag
    - xfs: update the pag for the last AG at recovery time
    - xfs: Reduce unnecessary searches when searching for the best extents
    - xfs: streamline xfs_filestream_pick_ag
    - xfs: Check for delayed allocations before setting extsize
    - md/md-bitmap: replace md_bitmap_status() with a new helper
      md_bitmap_get_stats()
    - md/md-cluster: fix spares warnings for __le64
    - md/md-bitmap: add 'sync_size' into struct md_bitmap_stats
    - mm: update mark_victim tracepoints fields
    - cpufreq: dt-platdev: add missing MODULE_DESCRIPTION() macro
    - cpufreq: fix using cpufreq-dt as module
    - Bluetooth: qca: Support downloading board id specific NVM for WCN7850
    - Bluetooth: qca: Update firmware-name to support board specific nvm
    - Bluetooth: qca: Fix poor RF performance for WCN6855
    - Input: serio - define serio_pause_rx guard to pause and resume serio
      ports
    - ASoC: renesas: rz-ssi: Add a check for negative sample_space
    - ASoC: rockchip: i2s-tdm: fix shift config for SND_SOC_DAIFMT_DSP_[AB]
    - powerpc/64s/mm: Move __real_pte stubs into hash-4k.h
    - powerpc/64s: Rewrite __real_pte() and __rpte_to_hidx() as static inline
    - ALSA: seq: Drop UMP events when no UMP-conversion is set
    - ibmvnic: Return error code on TX scrq flush fail
    - ibmvnic: Introduce send sub-crq direct
    - ibmvnic: Add stat for tx direct vs tx batched
    - vsock/bpf: Warn on socket without transport
    - tcp: adjust rcvq_space after updating scaling ratio
    - geneve: Suppress list corruption splat in geneve_destroy_tunnels().
    - flow_dissector: Fix handling of mixed port and port-range keys
    - flow_dissector: Fix port range key handling in BPF conversion
    - net: Add non-RCU dev_getbyhwaddr() helper
    - arp: switch to dev_getbyhwaddr() in arp_req_set_public()
    - net: axienet: Set mac_managed_pm
    - bpf: unify VM_WRITE vs VM_MAYWRITE use in BPF map mmaping logic
    - strparser: Add read_sock callback
    - bpf: Fix wrong copied_seq calculation
    - bpf: Disable non stream socket for strparser
    - power: supply: da9150-fg: fix potential overflow
    - nouveau/svm: fix missing folio unlock + put after
      make_device_exclusive_range()
    - drm/msm: Avoid rounding up to one jiffy
    - nvme/ioctl: add missing space in err message
    - bpf: skip non exist keys in generic_map_lookup_batch
    - drm/nouveau/pmu: Fix gp10b firmware guard
    - drm/msm/dpu: Disable dither in phys encoder cleanup
    - drm/i915: Make sure all planes in use by the joiner have their crtc
      included
    - drm/i915/dp: Fix error handling during 128b/132b link training
    - soc: loongson: loongson2_guts: Add check for devm_kstrdup()


=== debian/control ===
Source: linux
Section: devel
Priority: optional
Maintainer: Trisquel GNU/Linux-libre developers <trisquel-devel@listas.trisquel.info>
XSC-Ubuntu-Compatible-Signing: ubuntu/4 pro/3
Rules-Requires-Root: no
Standards-Version: 3.9.4.0
Build-Depends:
 gcc-13, gcc-13-aarch64-linux-gnu [arm64] <cross>, gcc-13-arm-linux-gnueabihf [armhf] <cross>, gcc-13-powerpc64le-linux-gnu [ppc64el] <cross>, gcc-13-riscv64-linux-gnu [riscv64] <cross>, gcc-13-s390x-linux-gnu [s390x] <cross>, gcc-13-x86-64-linux-gnu [amd64] <cross>,
 kernel-wedge <!stage1> <!noudeb> <!cross> <!autopkgtest>,
 dctrl-tools <!stage1> <!noudeb> <!cross> <!autopkgtest>,
 autoconf <!stage1>,
 automake <!stage1>,
 bc <!stage1>,
 bindgen-0.65 [amd64 arm64 armhf ppc64el riscv64 s390x],
 bison <!stage1>,
 clang-18 [amd64 arm64 armhf ppc64el riscv64 s390x],
 cpio,
 curl <!stage1>,
 debhelper-compat (= 10),
 default-jdk-headless <!stage1>,
 dkms <!stage1>,
 dwarfdump <!stage1>,
 flex <!stage1>,
 gawk <!stage1>,
 java-common <!stage1>,
 kmod <!stage1>,
 libaudit-dev <!stage1>,
 libcap-dev <!stage1>,
 libdw-dev <!stage1>,
 libelf-dev <!stage1>,
 libiberty-dev <!stage1>,
 liblzma-dev <!stage1>,
 libnewt-dev <!stage1>,
 libnuma-dev [amd64 arm64 ppc64el s390x] <!stage1>,
 libpci-dev <!stage1>,
 libssl-dev <!stage1>,
 libstdc++-dev,
 libtool <!stage1>,
 libtraceevent-dev [amd64 arm64 armhf ppc64el s390x riscv64] <!stage1>,
 libtracefs-dev [amd64 arm64 armhf ppc64el s390x riscv64] <!stage1>,
 libudev-dev <!stage1>,
 libunwind8-dev [amd64 arm64 armhf ppc64el] <!stage1>,
 makedumpfile [amd64] <!stage1>,
 openssl <!stage1>,
 pahole [amd64 arm64 armhf ppc64el s390x riscv64] | dwarves (>= 1.21) [amd64 arm64 armhf ppc64el s390x riscv64] <!stage1>,
 pkg-config <!stage1>,
 python3 <!stage1>,
 python3-dev <!stage1>,
 python3-setuptools <!stage1>,
 rsync [!i386] <!stage1>,
 rust-src [amd64 arm64 armhf ppc64el riscv64 s390x],
 rustc [amd64 arm64 armhf ppc64el riscv64 s390x],
 rustfmt [amd64 arm64 armhf ppc64el riscv64 s390x],
 uuid-dev <!stage1>,
 zstd <!stage1>,
Build-Depends-Indep:
 asciidoc <!stage1>,
 bzip2 <!stage1>,
 python3-docutils <!stage1>,
 sharutils <!stage1>,
 xmlto <!stage1>,
Vcs-Git: https://gitlab.trisquel.org/trisquel/package-helpers
XS-Testsuite: autopkgtest
#XS-Testsuite-Depends: gcc-4.7 binutils

Package: linux-headers-6.8.0-78
Build-Profiles: <!stage1>
Architecture: all
Multi-Arch: foreign
Section: devel
Priority: optional
Depends: ${misc:Depends}, coreutils
Description: Header files related to Linux-libre kernel version 6.8.0
 This package provides kernel header files for version 6.8.0, for sites
 that want the latest kernel headers. Please read
 /usr/share/doc/linux-headers-6.8.0-78/debian.README.gz for details

Package: linux-tools-6.8.0-78
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-tools-common
Description: Linux-libre kernel version specific tools for version 6.8.0-78
 This package provides the architecture dependant parts for kernel
 version locked tools (such as perf and x86_energy_perf_policy) for
 version 6.8.0-78 on
 64 bit x86.
 You probably want to install linux-tools-6.8.0-78-<flavour>.

Package: linux-cloud-tools-6.8.0-78
Build-Profiles: <!stage1>
Architecture: amd64 armhf
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-cloud-tools-common
Description: Linux-libre kernel version specific cloud tools for version 6.8.0-78
 This package provides the architecture dependant parts for kernel
 version locked tools for cloud tools for version 6.8.0-78 on
 64 bit x86.
 You probably want to install linux-cloud-tools-6.8.0-78-<flavour>.

Package: linux-libc-dev
Architecture: amd64 armhf arm64 i386 ppc64el riscv64 s390x
Depends: ${misc:Depends}
Conflicts: linux-kernel-headers
Replaces: linux-kernel-headers
Provides: linux-kernel-headers, aufs-dev
Multi-Arch: same
Description: Linux Kernel Headers for development
 This package provides headers from the Linux kernel.  These headers
 are used by the installed headers for GNU glibc and other system
 libraries. They are NOT meant to be used to build third-party modules for
 your kernel. Use linux-headers-* packages for that.

Package: linux-tools-common
Build-Profiles: <!stage1>
Architecture: all
Multi-Arch: foreign
Section: kernel
Priority: optional
Provides: bpftool
Depends: ${misc:Depends}, lsb-release, hwdata
Description: Linux kernel version specific tools for version 6.8.0
 This package provides the architecture independent parts for kernel
 version locked tools (such as perf and x86_energy_perf_policy) for
 version 6.8.0.

Package: linux-cloud-tools-common
Build-Profiles: <!stage1>
Architecture: all
Multi-Arch: foreign
Section: kernel
Priority: optional
Depends: ${misc:Depends}
Description: Linux kernel version specific cloud tools for version 6.8.0
 This package provides the architecture independent parts for kernel
 version locked tools for cloud tools for version 6.8.0.

Package: linux-tools-host
Build-Profiles: <!stage1>
Architecture: all
Multi-Arch: foreign
Section: kernel
Priority: optional
Depends: ${misc:Depends}, python3
Description: Linux kernel VM host tools
 This package provides kernel tools useful for VM hosts.

Package: linux-source-6.8.0
Build-Profiles: <!stage1>
Architecture: all
Section: devel
Priority: optional
Provides: linux-source
Depends: ${misc:Depends}, binutils, bzip2, coreutils
Recommends: libc-dev, gcc, make
Suggests: libncurses-dev | ncurses-dev, kernel-package, libqt3-dev
Description: Linux kernel source for version 6.8.0 with Ubuntu patches
 This package provides the source code for the Linux kernel version
 6.8.0.
 .
 This package is mainly meant for other packages to use, in order to build
 custom flavours.
 .
 If you wish to use this package to create a custom Linux kernel, then it
 is suggested that you investigate the package kernel-package, which has
 been designed to ease the task of creating kernel image packages.
 .
 If you are simply trying to build third-party modules for your kernel,
 you do not want this package. Install the appropriate linux-headers
 package instead.

Package: linux-doc
Build-Profiles: <!stage1>
Architecture: all
Section: doc
Priority: optional
Description: Linux kernel specific documentation for version 6.8.0
 This package is deprecated and it is temporarily provided only for
 compatibility reasons. It will be dropped in the future.

Package: linux-bpf-dev
Architecture: amd64 armhf arm64 i386 ppc64el riscv64 s390x
Depends: ${misc:Depends}
Multi-Arch: same
Description: Headers for BPF development
 The vmlinux.h header is provided to allow userspace to build BPF CO-RE
 programs targeting the packaged kernel.


Package: linux-image-6.8.0-78-generic
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: kernel
Priority: optional
Provides: linux-image, fuse-module, kvm-api-4, redhat-cluster-modules, ivtv-modules, virtualbox-guest-modules [amd64], ${linux:rprovides}
Depends: ${misc:Depends}, ${shlibs:Depends}, kmod, linux-base (>= 4.5ubuntu1~16.04.1), linux-modules-6.8.0-78-generic
Recommends: grub-pc [amd64] | grub-efi-amd64 [amd64] | grub-efi-ia32 [amd64] | grub [amd64] | lilo [amd64] | flash-kernel [armhf arm64] | grub-efi-arm64 [arm64] | grub-efi-arm [armhf] | grub-ieee1275 [ppc64el], initramfs-tools | linux-initramfs-tool
Breaks: flash-kernel (<< 3.90ubuntu2) [arm64 armhf], s390-tools (<< 2.3.0-0ubuntu3) [s390x]
Conflicts: linux-image-6.8.0-78-generic
Suggests: fdutils, linux-tools, linux-headers-6.8.0-78-generic, linux-modules-extra-6.8.0-78-generic
Description: Linux-libre kernel image for version 6.8.0 
 This package contains the Linux-libre kernel image for version 6.8.0
 .
 Supports Generic processors.
 .
 Geared toward desktop and server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-generic meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-modules-6.8.0-78-generic
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${linux:BuiltUsing}
Description: Linux-libre kernel extra modules for version 6.8.0 
 Contains the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports Generic processors.
 .
 Geared toward desktop and server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-generic meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-modules-extra-6.8.0-78-generic
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-modules-6.8.0-78-generic, wireless-regdb
Description: Linux-libre kernel extra modules for version 6.8.0 
 This package contains the Linux-libre kernel extra modules for version 6.8.0
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports Generic processors.
 .
 Geared toward desktop and server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-generic meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-headers-6.8.0-78-generic
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-headers-6.8.0-78, ${shlibs:Depends}
Provides: linux-headers, linux-headers-3.0
Description: Linux-libre kernel headers for version 6.8.0 
 This package provides kernel header files for version 6.8.0
 .
 This is for sites that want the latest kernel headers.  Please read
 /usr/share/doc/linux-headers-6.8.0-78/debian.README.gz for details.

Package: linux-lib-rust-6.8.0-78-generic
Build-Profiles: <!stage1>
Architecture: amd64
Multi-Arch: foreign
Section: devel
Priority: optional
Depends: ${misc:Depends}, coreutils
Description: Rust library files related to Linux-libre kernel version 6.8.0
 This package provides kernel library files for version 6.8.0, that allow to
 compile out-of-tree kernel modules written in Rust.

Package: linux-image-6.8.0-78-generic-dbgsym
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: devel
Priority: optional
Depends: ${misc:Depends}
Provides: linux-debug
Description: Linux-libre kernel debug image for version 6.8.0 
 This package provides the kernel debug image for version 6.8.0
 .
 This is for sites that wish to debug the kernel.
 .
 The kernel image contained in this package is NOT meant to boot from. It
 is uncompressed, and unstripped. This package also includes the
 unstripped modules.

Package: linux-tools-6.8.0-78-generic
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-tools-6.8.0-78
Description: Linux-libre kernel version specific tools for version 6.8.0-78
 This package provides the architecture dependant parts for kernel
 version locked tools (such as perf and x86_energy_perf_policy) for
 version 6.8.0-78 on
 64 bit x86.

Package: linux-cloud-tools-6.8.0-78-generic
Build-Profiles: <!stage1>
Architecture: amd64 armhf arm64 ppc64el s390x
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-cloud-tools-6.8.0-78
Description: Linux-libre kernel version specific cloud tools for version 6.8.0-78
 This package provides the architecture dependant parts for kernel
 version locked tools for cloud for version 6.8.0-78 on
 64 bit x86.

## linux 6.8.0-79.79trisquel35

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
VERSION = 6
PATCHLEVEL = 8
SUBLEVEL = 12
EXTRAVERSION = -gnu
NAME = Hurr durr I'ma ninja sloth

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

ifeq ($(filter undefine,$(.FEATURES)),)
$(error GNU Make >= 3.82 is required. Your Make version is $(MAKE_VERSION))
endif

$(if $(filter __%, $(MAKECMDGOALS)), \
	$(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.a targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

this-makefile := $(lastword $(MAKEFILE_LIST))
export abs_srctree := $(realpath $(dir $(this-makefile)))
export abs_objtree := $(CURDIR)

ifneq ($(sub_make_done),1)

# Do not use make's built-in rules and variables
# (this increases performance and avoids hard-to-debug behaviour)
MAKEFLAGS += -rR

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# Beautify output
# ---------------------------------------------------------------------------
#
# Most of build commands in Kbuild start with "cmd_". You can optionally define
# "quiet_cmd_*". If defined, the short log is printed. Otherwise, no log from
# that command is printed by default.
#
# e.g.)
#    quiet_cmd_depmod = DEPMOD  $(MODLIB)
#          cmd_depmod = $(srctree)/scripts/depmod.sh $(DEPMOD) $(KERNELRELEASE)
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#    $(Q)$(MAKE) $(build)=scripts/basic
#
# If KBUILD_VERBOSE contains 1, the whole command is echoed.
# If KBUILD_VERBOSE contains 2, the reason for rebuilding is printed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif

quiet = quiet_
Q = @

ifneq ($(findstring 1, $(KBUILD_VERBOSE)),)
  quiet =
  Q =
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands
# make-4.0 (and later) keep single letter options in the 1st word of MAKEFLAGS.

ifeq ($(filter 3.%,$(MAKE_VERSION)),)
short-opts := $(firstword -$(MAKEFLAGS))
else
short-opts := $(filter-out --%,$(MAKEFLAGS))
endif

ifneq ($(findstring s,$(short-opts)),)
quiet=silent_
override KBUILD_VERBOSE :=
endif

export quiet Q KBUILD_VERBOSE

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/dev-tools/sparse.rst" for more details,
# including where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

export KBUILD_CHECKSRC

# Enable "clippy" (a linter) as part of the Rust compilation.
#
# Use 'make CLIPPY=1' to enable it.
ifeq ("$(origin CLIPPY)", "command line")
  KBUILD_CLIPPY := $(CLIPPY)
endif

export KBUILD_CLIPPY

# Use make M=dir or set the environment variable KBUILD_EXTMOD to specify the
# directory of external module to build. Setting M= takes precedence.
ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

$(if $(word 2, $(KBUILD_EXTMOD)), \
	$(error building multiple external modules is not supported))

$(foreach x, % :, $(if $(findstring $x, $(KBUILD_EXTMOD)), \
	$(error module directory path cannot contain '$x')))

# Remove trailing slashes
ifneq ($(filter %/, $(KBUILD_EXTMOD)),)
KBUILD_EXTMOD := $(shell dirname $(KBUILD_EXTMOD).)
endif

export KBUILD_EXTMOD

# backward compatibility
KBUILD_EXTRA_WARN ?= $(KBUILD_ENABLE_EXTRA_GCC_CHECKS)

ifeq ("$(origin W)", "command line")
  KBUILD_EXTRA_WARN := $(W)
endif

export KBUILD_EXTRA_WARN

# Kbuild will save output files in the current working directory.
# This does not need to match to the root of the kernel source tree.
#
# For example, you can do this:
#
#  cd /dir/to/store/output/files; make -f /dir/to/kernel/source/Makefile
#
# If you want to save output files in a different location, there are
# two syntaxes to specify it.
#
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the output directory.
# export KBUILD_OUTPUT=dir/to/store/output/files/; make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# Do we want to change the working directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# $(realpath ...) gets empty if the path does not exist. Run 'mkdir -p' first.
$(shell mkdir -p "$(KBUILD_OUTPUT)")
# $(realpath ...) resolves symlinks
abs_objtree := $(realpath $(KBUILD_OUTPUT))
$(if $(abs_objtree),,$(error failed to create output directory "$(KBUILD_OUTPUT)"))
endif # ifneq ($(KBUILD_OUTPUT),)

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

ifneq ($(filter 3.%,$(MAKE_VERSION)),)
# 'MAKEFLAGS += -rR' does not immediately become effective for GNU Make 3.x
# We need to invoke sub-make to avoid implicit rules in the top Makefile.
need-sub-make := 1
# Cancel implicit rules for this Makefile.
$(this-makefile): ;
endif

export sub_make_done := 1

endif # sub_make_done

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." if we are at the final work directory.
no-print-directory := --no-print-directory
else
# Recursion to show "Entering directory ..."
need-sub-make := 1
endif

ifeq ($(filter --no-print-directory, $(MAKEFLAGS)),)
# If --no-print-directory is unset, recurse once again to set it.
# You may end up recursing into __sub-make twice. This is needed due to the
# behavior change in GNU Make 4.4.1.
need-sub-make := 1
endif

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) $(no-print-directory) -C $(abs_objtree) \
	-f $(abs_srctree)/Makefile $(MAKECMDGOALS)

else # need-sub-make

# We process the rest of the Makefile if this is the final invocation of make

ifeq ($(abs_srctree),$(abs_objtree))
        # building in the source tree
        srctree := .
	building_out_of_srctree :=
else
        ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(abs_srctree)
        endif
	building_out_of_srctree := 1
endif

ifneq ($(KBUILD_ABS_SRCTREE),)
srctree := $(abs_srctree)
endif

objtree		:= .
VPATH		:= $(srctree)

export building_out_of_srctree srctree objtree VPATH

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

version_h := include/generated/uapi/linux/version.h

clean-targets := %clean mrproper cleandocs
no-dot-config-targets := $(clean-targets) \
			 cscope gtags TAGS tags help% %docs check% coccicheck \
			 $(version_h) headers headers_% archheaders archscripts \
			 %asm-generic kernelversion %src-pkg dt_binding_check \
			 outputmakefile rustavailable rustfmt rustfmtcheck
no-sync-config-targets := $(no-dot-config-targets) %install modules_sign kernelrelease \
			  image_name
single-targets := %.a %.i %.ko %.lds %.ll %.lst %.mod %.o %.rsi %.s %.symtypes %/

config-build	:=
mixed-build	:=
need-config	:= 1
may-sync-config	:= 1
single-build	:=

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
		need-config :=
    endif
endif

ifneq ($(filter $(no-sync-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-sync-config-targets), $(MAKECMDGOALS)),)
		may-sync-config :=
    endif
endif

need-compiler := $(may-sync-config)

ifneq ($(KBUILD_EXTMOD),)
	may-sync-config :=
endif

ifeq ($(KBUILD_EXTMOD),)
        ifneq ($(filter %config,$(MAKECMDGOALS)),)
		config-build := 1
                ifneq ($(words $(MAKECMDGOALS)),1)
			mixed-build := 1
                endif
        endif
endif

# We cannot build single targets and the others at the same time
ifneq ($(filter $(single-targets), $(MAKECMDGOALS)),)
	single-build := 1
    ifneq ($(filter-out $(single-targets), $(MAKECMDGOALS)),)
		mixed-build := 1
    endif
endif

# For "make -j clean all", "make -j mrproper defconfig all", etc.
ifneq ($(filter $(clean-targets),$(MAKECMDGOALS)),)
        ifneq ($(filter-out $(clean-targets),$(MAKECMDGOALS)),)
		mixed-build := 1
        endif
endif

# install and modules_install need also be processed one by one
ifneq ($(filter install,$(MAKECMDGOALS)),)
        ifneq ($(filter modules_install,$(MAKECMDGOALS)),)
		mixed-build := 1
        endif
endif

ifdef mixed-build
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.

PHONY += $(MAKECMDGOALS) __build_one_by_one

$(MAKECMDGOALS): __build_one_by_one
	@:

__build_one_by_one:
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done

else # !mixed-build

include $(srctree)/scripts/Kbuild.include

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(call read-file, include/config/kernel.release)
KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
export VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION

include $(srctree)/scripts/subarch.include

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=arm64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=aarch64-linux-gnu-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
ARCH		?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86

=== debian/changelog ===
linux (6.8.0-79.79trisquel35) ecne; urgency=medium

  * Removed non-free bits

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 27 Aug 2025 08:08:46 +0000

linux (6.8.0-79.79) noble; urgency=medium

  * noble/linux: 6.8.0-79.79 -proposed tracker (LP: #2120415)

  * CVE-2024-57996 // CVE-2025-37752
    - net_sched: sch_sfq: move the limit validation

  * CVE-2025-38350
    - net/sched: Always pass notifications when child class becomes empty

  * CVE-2025-21887
    - ovl: fix UAF in ovl_dentry_update_reval by moving dput() in ovl_link_up

 -- Stefan Bader <stefan.bader@canonical.com>  Tue, 12 Aug 2025 12:33:51 +0200

=== debian/control ===
--- 
+++ 
@@ -64,7 +64,7 @@
 XS-Testsuite: autopkgtest
 #XS-Testsuite-Depends: gcc-4.7 binutils
 
-Package: linux-headers-6.8.0-78
+Package: linux-headers-6.8.0-79
 Build-Profiles: <!stage1>
 Architecture: all
 Multi-Arch: foreign
@@ -74,32 +74,32 @@
 Description: Header files related to Linux-libre kernel version 6.8.0
  This package provides kernel header files for version 6.8.0, for sites
  that want the latest kernel headers. Please read
- /usr/share/doc/linux-headers-6.8.0-78/debian.README.gz for details
-
-Package: linux-tools-6.8.0-78
+ /usr/share/doc/linux-headers-6.8.0-79/debian.README.gz for details
+
+Package: linux-tools-6.8.0-79
 Build-Profiles: <!stage1>
 Architecture: amd64 armhf arm64 ppc64el s390x
 Section: devel
 Priority: optional
 Depends: ${misc:Depends}, ${shlibs:Depends}, linux-tools-common
-Description: Linux-libre kernel version specific tools for version 6.8.0-78
+Description: Linux-libre kernel version specific tools for version 6.8.0-79
  This package provides the architecture dependant parts for kernel
  version locked tools (such as perf and x86_energy_perf_policy) for
- version 6.8.0-78 on
+ version 6.8.0-79 on
  64 bit x86.
- You probably want to install linux-tools-6.8.0-78-<flavour>.
-
-Package: linux-cloud-tools-6.8.0-78
+ You probably want to install linux-tools-6.8.0-79-<flavour>.
+
+Package: linux-cloud-tools-6.8.0-79
 Build-Profiles: <!stage1>
 Architecture: amd64 armhf
 Section: devel
 Priority: optional
 Depends: ${misc:Depends}, ${shlibs:Depends}, linux-cloud-tools-common
-Description: Linux-libre kernel version specific cloud tools for version 6.8.0-78
+Description: Linux-libre kernel version specific cloud tools for version 6.8.0-79
  This package provides the architecture dependant parts for kernel
- version locked tools for cloud tools for version 6.8.0-78 on
+ version locked tools for cloud tools for version 6.8.0-79 on
  64 bit x86.
- You probably want to install linux-cloud-tools-6.8.0-78-<flavour>.
+ You probably want to install linux-cloud-tools-6.8.0-79-<flavour>.
 
 Package: linux-libc-dev
 Architecture: amd64 armhf arm64 i386 ppc64el riscv64 s390x
@@ -190,17 +190,17 @@
  programs targeting the packaged kernel.
 
 
-Package: linux-image-6.8.0-78-generic
+Package: linux-image-6.8.0-79-generic
 Build-Profiles: <!stage1>
 Architecture: amd64 armhf arm64 ppc64el s390x
 Section: kernel
 Priority: optional
 Provides: linux-image, fuse-module, kvm-api-4, redhat-cluster-modules, ivtv-modules, virtualbox-guest-modules [amd64], ${linux:rprovides}
-Depends: ${misc:Depends}, ${shlibs:Depends}, kmod, linux-base (>= 4.5ubuntu1~16.04.1), linux-modules-6.8.0-78-generic
+Depends: ${misc:Depends}, ${shlibs:Depends}, kmod, linux-base (>= 4.5ubuntu1~16.04.1), linux-modules-6.8.0-79-generic
 Recommends: grub-pc [amd64] | grub-efi-amd64 [amd64] | grub-efi-ia32 [amd64] | grub [amd64] | lilo [amd64] | flash-kernel [armhf arm64] | grub-efi-arm64 [arm64] | grub-efi-arm [armhf] | grub-ieee1275 [ppc64el], initramfs-tools | linux-initramfs-tool
 Breaks: flash-kernel (<< 3.90ubuntu2) [arm64 armhf], s390-tools (<< 2.3.0-0ubuntu3) [s390x]
-Conflicts: linux-image-6.8.0-78-generic
-Suggests: fdutils, linux-tools, linux-headers-6.8.0-78-generic, linux-modules-extra-6.8.0-78-generic
+Conflicts: linux-image-6.8.0-79-generic
+Suggests: fdutils, linux-tools, linux-headers-6.8.0-79-generic, linux-modules-extra-6.8.0-79-generic
 Description: Linux-libre kernel image for version 6.8.0 
  This package contains the Linux-libre kernel image for version 6.8.0
  .
@@ -212,7 +212,7 @@
  the linux-generic meta-package, which will ensure that upgrades work
  correctly, and that supporting packages are also installed.
 
-Package: linux-modules-6.8.0-78-generic
+Package: linux-modules-6.8.0-79-generic
 Build-Profiles: <!stage1>
 Architecture: amd64 armhf arm64 ppc64el s390x
 Section: kernel
@@ -232,12 +232,12 @@
  the linux-generic meta-package, which will ensure that upgrades work
  correctly, and that supporting packages are also installed.
 
-Package: linux-modules-extra-6.8.0-78-generic
-Build-Profiles: <!stage1>
-Architecture: amd64 armhf arm64 ppc64el s390x
-Section: kernel
-Priority: optional
-Depends: ${misc:Depends}, ${shlibs:Depends}, linux-modules-6.8.0-78-generic, wireless-regdb
+Package: linux-modules-extra-6.8.0-79-generic
+Build-Profiles: <!stage1>
+Architecture: amd64 armhf arm64 ppc64el s390x
+Section: kernel
+Priority: optional
+Depends: ${misc:Depends}, ${shlibs:Depends}, linux-modules-6.8.0-79-generic, wireless-regdb
 Description: Linux-libre kernel extra modules for version 6.8.0 
  This package contains the Linux-libre kernel extra modules for version 6.8.0
  .
@@ -253,20 +253,20 @@
  the linux-generic meta-package, which will ensure that upgrades work
  correctly, and that supporting packages are also installed.
 
-Package: linux-headers-6.8.0-78-generic
-Build-Profiles: <!stage1>
-Architecture: amd64 armhf arm64 ppc64el s390x
-Section: devel
-Priority: optional
-Depends: ${misc:Depends}, linux-headers-6.8.0-78, ${shlibs:Depends}
+Package: linux-headers-6.8.0-79-generic
+Build-Profiles: <!stage1>
+Architecture: amd64 armhf arm64 ppc64el s390x
+Section: devel
+Priority: optional
+Depends: ${misc:Depends}, linux-headers-6.8.0-79, ${shlibs:Depends}
 Provides: linux-headers, linux-headers-3.0
 Description: Linux-libre kernel headers for version 6.8.0 
  This package provides kernel header files for version 6.8.0
  .
  This is for sites that want the latest kernel headers.  Please read
- /usr/share/doc/linux-headers-6.8.0-78/debian.README.gz for details.
-
-Package: linux-lib-rust-6.8.0-78-generic
+ /usr/share/doc/linux-headers-6.8.0-79/debian.README.gz for details.
+
+Package: linux-lib-rust-6.8.0-79-generic
 Build-Profiles: <!stage1>
 Architecture: amd64
 Multi-Arch: foreign
@@ -277,7 +277,7 @@
  This package provides kernel library files for version 6.8.0, that allow to
  compile out-of-tree kernel modules written in Rust.
 
-Package: linux-image-6.8.0-78-generic-dbgsym
+Package: linux-image-6.8.0-79-generic-dbgsym
 Build-Profiles: <!stage1>
 Architecture: amd64 armhf arm64 ppc64el s390x
 Section: devel
@@ -293,26 +293,26 @@
  is uncompressed, and unstripped. This package also includes the
  unstripped modules.
 
-Package: linux-tools-6.8.0-78-generic
-Build-Profiles: <!stage1>
-Architecture: amd64 armhf arm64 ppc64el s390x
-Section: devel
-Priority: optional
-Depends: ${misc:Depends}, linux-tools-6.8.0-78
-Description: Linux-libre kernel version specific tools for version 6.8.0-78
+Package: linux-tools-6.8.0-79-generic
+Build-Profiles: <!stage1>
+Architecture: amd64 armhf arm64 ppc64el s390x
+Section: devel
+Priority: optional
+Depends: ${misc:Depends}, linux-tools-6.8.0-79
+Description: Linux-libre kernel version specific tools for version 6.8.0-79
  This package provides the architecture dependant parts for kernel
  version locked tools (such as perf and x86_energy_perf_policy) for
- version 6.8.0-78 on
+ version 6.8.0-79 on
  64 bit x86.
 
-Package: linux-cloud-tools-6.8.0-78-generic
-Build-Profiles: <!stage1>
-Architecture: amd64 armhf arm64 ppc64el s390x
-Section: devel
-Priority: optional
-Depends: ${misc:Depends}, linux-cloud-tools-6.8.0-78
-Description: Linux-libre kernel version specific cloud tools for version 6.8.0-78
+Package: linux-cloud-tools-6.8.0-79-generic
+Build-Profiles: <!stage1>
+Architecture: amd64 armhf arm64 ppc64el s390x
+Section: devel
+Priority: optional
+Depends: ${misc:Depends}, linux-cloud-tools-6.8.0-79
+Description: Linux-libre kernel version specific cloud tools for version 6.8.0-79
  This package provides the architecture dependant parts for kernel
- version locked tools for cloud for version 6.8.0-78 on
+ version locked tools for cloud for version 6.8.0-79 on
  64 bit x86.
